# Excel Validator

Excel Validator is a Python package designed to validate Excel files (.xlsx) based on configured schemas. The tool ensures your Excel files adhere to specified schemas and generates detailed reports in case of validation errors. Built on the robust Frictionless library, Excel Validator also allows for dynamic schema creation, where fields are included based on row data from other sheets.

## Features

* Validate Excel files against predefined schemas.
* Generate detailed reports highlighting any validation issues.
* Dynamic schema creation based on data from other sheets.
* Easy integration with your existing data processing workflows.
* Built on top of the Frictionless library for reliable and extensible validation.

## Installation

You can install Excel Validator via pip:

```
pip install excel-validator
```


---
This software has been developed for the [AGENT](https://www.agent-project.eu/) project

